unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ImgList, ComCtrls, ToolWin;

type
  TForm1 = class(TForm)
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ImageList1: TImageList;
    procedure FormDockDrop(Sender: TObject; Source: TDragDockObject; X,
      Y: Integer);
    procedure FormUnDock(Sender: TObject; Client: TControl;
      NewTarget: TWinControl; var Allow: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormDockDrop(Sender: TObject; Source: TDragDockObject; X,
    Y: Integer);
var
    ARect: TRect;
begin
    ARect := ClientRect;
    if Y<=40 then begin
        { top }
        ARect.Bottom := 40;
        CoolBar1.Height := 40;
        CoolBar1.Align := alTop;
        CoolBar1.Vertical := False; end
    else if Y>=ClientHeight-40 then begin
        { bottom }
        ARect.Top := ClientHeight - 40;
        CoolBar1.Align := alBottom;
        CoolBar1.Height := 40;
        CoolBar1.Vertical := False; end
    else if X<=36 then begin
        { left }
        ARect.Right := 65;
        CoolBar1.Width := 65;
        CoolBar1.Align := alLeft;
        CoolBar1.Vertical := True; end
    else begin
        { right }
        ARect.Left := ClientWidth - 65;
        CoolBar1.Width := 65;
        CoolBar1.Align := alRight;
        CoolBar1.Vertical := True;
    end;
    CoolBar1.Dock(self,ARect);
end;

procedure TForm1.FormUnDock(Sender: TObject; Client: TControl;
    NewTarget: TWinControl; var Allow: Boolean);
begin
    if not Assigned(NewTarget) then with CoolBar1 do begin
        Width := 65;
        Align := alLeft;
    end;
end;

end.
